#[repr(u32)]
#[derive(SettingsSchema, Serialize, Deserialize, Clone, Debug)]
pub enum OpenvrProperty {
    TrackingSystemName(String) = 1000,
    ModelNumber(String) = 1001,
    SerialNumber(String) = 1002,
    RenderModelName(String) = 1003,
    WillDriftInYaw(bool) = 1004,
    ManufacturerName(String) = 1005,
    TrackingFirmwareVersion(String) = 1006,
    HardwareRevisionString(String) = 1007,
    AllWirelessDongleDescriptions(String) = 1008,
    ConnectedWirelessDongle(String) = 1009,
    DeviceIsWireless(bool) = 1010,
    DeviceIsCharging(bool) = 1011,
    DeviceBatteryPercentage(f32) = 1012,
    FirmwareUpdateAvailable(bool) = 1014,
    FirmwareManualUpdate(bool) = 1015,
    FirmwareManualUpdateURL(String) = 1016,
    HardwareRevisionUint64(u64) = 1017,
    FirmwareVersion(u64) = 1018,
    FPGAVersion(u64) = 1019,
    VRCVersion(u64) = 1020,
    RadioVersion(u64) = 1021,
    DongleVersion(u64) = 1022,
    BlockServerShutdown(bool) = 1023,
    CanUnifyCoordinateSystemWithHmd(bool) = 1024,
    ContainsProximitySensor(bool) = 1025,
    DeviceProvidesBatteryStatus(bool) = 1026,
    DeviceCanPowerOff(bool) = 1027,
    FirmwareProgrammingTarget(String) = 1028,
    DeviceClass(i32) = 1029,
    HasCamera(bool) = 1030,
    DriverVersion(String) = 1031,
    FirmwareForceUpdateRequired(bool) = 1032,
    ViveSystemButtonFixRequired(bool) = 1033,
    ParentDriver(u64) = 1034,
    ResourceRoot(String) = 1035,
    RegisteredDeviceType(String) = 1036,
    InputProfilePath(String) = 1037,
    NeverTracked(bool) = 1038,
    NumCameras(i32) = 1039,
    CameraFrameLayout(i32) = 1040,
    CameraStreamFormat(i32) = 1041,
    AdditionalDeviceSettingsPath(String) = 1042,
    Identifiable(bool) = 1043,
    BootloaderVersion(u64) = 1044,
    AdditionalSystemReportData(String) = 1045,
    CompositeFirmwareVersion(String) = 1046,
    FirmwareRemindUpdate(bool) = 1047,
    PeripheralApplicationVersion(u64) = 1048,
    ManufacturerSerialNumber(String) = 1049,
    ComputedSerialNumber(String) = 1050,
    EstimatedDeviceFirstUseTime(i32) = 1051,
    ReportsTimeSinceVSync(bool) = 2000,
    SecondsFromVsyncToPhotons(f32) = 2001,
    DisplayFrequency(f32) = 2002,
    UserIpdMeters(f32) = 2003,
    CurrentUniverseId(u64) = 2004,
    PreviousUniverseId(u64) = 2005,
    DisplayFirmwareVersion(u64) = 2006,
    IsOnDesktop(bool) = 2007,
    DisplayMCType(i32) = 2008,
    DisplayMCOffset(f32) = 2009,
    DisplayMCScale(f32) = 2010,
    EdidVendorID(i32) = 2011,
    DisplayMCImageLeft(String) = 2012,
    DisplayMCImageRight(String) = 2013,
    DisplayGCBlackClamp(f32) = 2014,
    EdidProductID(i32) = 2015,
    DisplayGCType(i32) = 2017,
    DisplayGCOffset(f32) = 2018,
    DisplayGCScale(f32) = 2019,
    DisplayGCPrescale(f32) = 2020,
    DisplayGCImage(String) = 2021,
    LensCenterLeftU(f32) = 2022,
    LensCenterLeftV(f32) = 2023,
    LensCenterRightU(f32) = 2024,
    LensCenterRightV(f32) = 2025,
    UserHeadToEyeDepthMeters(f32) = 2026,
    CameraFirmwareVersion(u64) = 2027,
    CameraFirmwareDescription(String) = 2028,
    DisplayFPGAVersion(u64) = 2029,
    DisplayBootloaderVersion(u64) = 2030,
    DisplayHardwareVersion(u64) = 2031,
    AudioFirmwareVersion(u64) = 2032,
    CameraCompatibilityMode(i32) = 2033,
    ScreenshotHorizontalFieldOfViewDegrees(f32) = 2034,
    ScreenshotVerticalFieldOfViewDegrees(f32) = 2035,
    DisplaySuppressed(bool) = 2036,
    DisplayAllowNightMode(bool) = 2037,
    DisplayMCImageWidth(i32) = 2038,
    DisplayMCImageHeight(i32) = 2039,
    DisplayMCImageNumChannels(i32) = 2040,
    SecondsFromPhotonsToVblank(f32) = 2042,
    DriverDirectModeSendsVsyncEvents(bool) = 2043,
    DisplayDebugMode(bool) = 2044,
    GraphicsAdapterLuid(u64) = 2045,
    DriverProvidedChaperonePath(String) = 2048,
    ExpectedTrackingReferenceCount(i32) = 2049,
    ExpectedControllerCount(i32) = 2050,
    NamedIconPathControllerLeftDeviceOff(String) = 2051,
    NamedIconPathControllerRightDeviceOff(String) = 2052,
    NamedIconPathTrackingReferenceDeviceOff(String) = 2053,
    DoNotApplyPrediction(bool) = 2054,
    DistortionMeshResolution(i32) = 2056,
    DriverIsDrawingControllers(bool) = 2057,
    DriverRequestsApplicationPause(bool) = 2058,
    DriverRequestsReducedRendering(bool) = 2059,
    MinimumIpdStepMeters(f32) = 2060,
    AudioBridgeFirmwareVersion(u64) = 2061,
    ImageBridgeFirmwareVersion(u64) = 2062,
    ImuFactoryGyroBias([f32; 3]) = 2064,
    ImuFactoryGyroScale([f32; 3]) = 2065,
    ImuFactoryAccelerometerBias([f32; 3]) = 2066,
    ImuFactoryAccelerometerScale([f32; 3]) = 2067,
    ConfigurationIncludesLighthouse20Features(bool) = 2069,
    AdditionalRadioFeatures(u64) = 2070,
    ExpectedControllerType(String) = 2074,
    HmdTrackingStyle(i32) = 2075,
    DriverProvidedChaperoneVisibility(bool) = 2076,
    HmdColumnCorrectionSettingPrefix(String) = 2077,
    CameraSupportsCompatibilityModes(bool) = 2078,
    SupportsRoomViewDepthProjection(bool) = 2079,
    DisplaySupportsMultipleFramerates(bool) = 2081,
    DisplayColorMultLeft([f32; 3]) = 2082,
    DisplayColorMultRight([f32; 3]) = 2083,
    DisplaySupportsRuntimeFramerateChange(bool) = 2084,
    DisplaySupportsAnalogGain(bool) = 2085,
    DisplayMinAnalogGain(f32) = 2086,
    DisplayMaxAnalogGain(f32) = 2087,
    DashboardScale(f32) = 2091,
    IpdUIRangeMinMeters(f32) = 2100,
    IpdUIRangeMaxMeters(f32) = 2101,
    HmdSupportsHDCP14LegacyCompat(bool) = 2102,
    HmdSupportsMicMonitoring(bool) = 2103,
    DriverRequestedMuraCorrectionMode(i32) = 2200,
    DriverRequestedMuraFeatherInnerLeft(i32) = 2201,
    DriverRequestedMuraFeatherInnerRight(i32) = 2202,
    DriverRequestedMuraFeatherInnerTop(i32) = 2203,
    DriverRequestedMuraFeatherInnerBottom(i32) = 2204,
    DriverRequestedMuraFeatherOuterLeft(i32) = 2205,
    DriverRequestedMuraFeatherOuterRight(i32) = 2206,
    DriverRequestedMuraFeatherOuterTop(i32) = 2207,
    DriverRequestedMuraFeatherOuterBottom(i32) = 2208,
    AudioDefaultPlaybackDeviceId(String) = 2300,
    AudioDefaultRecordingDeviceId(String) = 2301,
    AudioDefaultPlaybackDeviceVolume(f32) = 2302,
    AudioSupportsDualSpeakerAndJackOutput(bool) = 2303,
    AttachedDeviceId(String) = 3000,
    SupportedButtons(u64) = 3001,
    Axis0Type(i32) = 3002,
    Axis1Type(i32) = 3003,
    Axis2Type(i32) = 3004,
    Axis3Type(i32) = 3005,
    Axis4Type(i32) = 3006,
    ControllerRoleHint(i32) = 3007,
    FieldOfViewLeftDegrees(f32) = 4000,
    FieldOfViewRightDegrees(f32) = 4001,
    FieldOfViewTopDegrees(f32) = 4002,
    FieldOfViewBottomDegrees(f32) = 4003,
    TrackingRangeMinimumMeters(f32) = 4004,
    TrackingRangeMaximumMeters(f32) = 4005,
    ModeLabel(String) = 4006,
    CanWirelessIdentify(bool) = 4007,
    Nonce(i32) = 4008,
    IconPathName(String) = 5000,
    NamedIconPathDeviceOff(String) = 5001,
    NamedIconPathDeviceSearching(String) = 5002,
    NamedIconPathDeviceSearchingAlert(String) = 5003,
    NamedIconPathDeviceReady(String) = 5004,
    NamedIconPathDeviceReadyAlert(String) = 5005,
    NamedIconPathDeviceNotReady(String) = 5006,
    NamedIconPathDeviceStandby(String) = 5007,
    NamedIconPathDeviceAlertLow(String) = 5008,
    NamedIconPathDeviceStandbyAlert(String) = 5009,
    OverrideContainer(u64) = 5152,
    UserConfigPath(String) = 6000,
    InstallPath(String) = 6001,
    HasDisplayComponent(bool) = 6002,
    HasControllerComponent(bool) = 6003,
    HasCameraComponent(bool) = 6004,
    HasDriverDirectModeComponent(bool) = 6005,
    HasVirtualDisplayComponent(bool) = 6006,
    HasSpatialAnchorsSupport(bool) = 6007,
    ControllerType(String) = 7000,
    ControllerHandSelectionPriority(i32) = 7002,
}

#[derive(Clone, Debug)]
pub enum OpenvrPropValue {
    Bool(bool),
    Float(f32),
    Int32(i32),
    Uint64(u64),
    Vector3([f32; 3]),
    Double(f64),
    String(String),
}

impl OpenvrProperty {
    pub fn into_key_value(self) -> (u32, OpenvrPropValue) {
        match self {
            OpenvrProperty::TrackingSystemName(value) => (1000, OpenvrPropValue::String(value)),
            OpenvrProperty::ModelNumber(value) => (1001, OpenvrPropValue::String(value)),
            OpenvrProperty::SerialNumber(value) => (1002, OpenvrPropValue::String(value)),
            OpenvrProperty::RenderModelName(value) => (1003, OpenvrPropValue::String(value)),
            OpenvrProperty::WillDriftInYaw(value) => (1004, OpenvrPropValue::Bool(value)),
            OpenvrProperty::ManufacturerName(value) => (1005, OpenvrPropValue::String(value)),
            OpenvrProperty::TrackingFirmwareVersion(value) => (1006, OpenvrPropValue::String(value)),
            OpenvrProperty::HardwareRevisionString(value) => (1007, OpenvrPropValue::String(value)),
            OpenvrProperty::AllWirelessDongleDescriptions(value) => (1008, OpenvrPropValue::String(value)),
            OpenvrProperty::ConnectedWirelessDongle(value) => (1009, OpenvrPropValue::String(value)),
            OpenvrProperty::DeviceIsWireless(value) => (1010, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DeviceIsCharging(value) => (1011, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DeviceBatteryPercentage(value) => (1012, OpenvrPropValue::Float(value)),
            OpenvrProperty::FirmwareUpdateAvailable(value) => (1014, OpenvrPropValue::Bool(value)),
            OpenvrProperty::FirmwareManualUpdate(value) => (1015, OpenvrPropValue::Bool(value)),
            OpenvrProperty::FirmwareManualUpdateURL(value) => (1016, OpenvrPropValue::String(value)),
            OpenvrProperty::HardwareRevisionUint64(value) => (1017, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::FirmwareVersion(value) => (1018, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::FPGAVersion(value) => (1019, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::VRCVersion(value) => (1020, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::RadioVersion(value) => (1021, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::DongleVersion(value) => (1022, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::BlockServerShutdown(value) => (1023, OpenvrPropValue::Bool(value)),
            OpenvrProperty::CanUnifyCoordinateSystemWithHmd(value) => (1024, OpenvrPropValue::Bool(value)),
            OpenvrProperty::ContainsProximitySensor(value) => (1025, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DeviceProvidesBatteryStatus(value) => (1026, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DeviceCanPowerOff(value) => (1027, OpenvrPropValue::Bool(value)),
            OpenvrProperty::FirmwareProgrammingTarget(value) => (1028, OpenvrPropValue::String(value)),
            OpenvrProperty::DeviceClass(value) => (1029, OpenvrPropValue::Int32(value)),
            OpenvrProperty::HasCamera(value) => (1030, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DriverVersion(value) => (1031, OpenvrPropValue::String(value)),
            OpenvrProperty::FirmwareForceUpdateRequired(value) => (1032, OpenvrPropValue::Bool(value)),
            OpenvrProperty::ViveSystemButtonFixRequired(value) => (1033, OpenvrPropValue::Bool(value)),
            OpenvrProperty::ParentDriver(value) => (1034, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::ResourceRoot(value) => (1035, OpenvrPropValue::String(value)),
            OpenvrProperty::RegisteredDeviceType(value) => (1036, OpenvrPropValue::String(value)),
            OpenvrProperty::InputProfilePath(value) => (1037, OpenvrPropValue::String(value)),
            OpenvrProperty::NeverTracked(value) => (1038, OpenvrPropValue::Bool(value)),
            OpenvrProperty::NumCameras(value) => (1039, OpenvrPropValue::Int32(value)),
            OpenvrProperty::CameraFrameLayout(value) => (1040, OpenvrPropValue::Int32(value)),
            OpenvrProperty::CameraStreamFormat(value) => (1041, OpenvrPropValue::Int32(value)),
            OpenvrProperty::AdditionalDeviceSettingsPath(value) => (1042, OpenvrPropValue::String(value)),
            OpenvrProperty::Identifiable(value) => (1043, OpenvrPropValue::Bool(value)),
            OpenvrProperty::BootloaderVersion(value) => (1044, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::AdditionalSystemReportData(value) => (1045, OpenvrPropValue::String(value)),
            OpenvrProperty::CompositeFirmwareVersion(value) => (1046, OpenvrPropValue::String(value)),
            OpenvrProperty::FirmwareRemindUpdate(value) => (1047, OpenvrPropValue::Bool(value)),
            OpenvrProperty::PeripheralApplicationVersion(value) => (1048, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::ManufacturerSerialNumber(value) => (1049, OpenvrPropValue::String(value)),
            OpenvrProperty::ComputedSerialNumber(value) => (1050, OpenvrPropValue::String(value)),
            OpenvrProperty::EstimatedDeviceFirstUseTime(value) => (1051, OpenvrPropValue::Int32(value)),
            OpenvrProperty::ReportsTimeSinceVSync(value) => (2000, OpenvrPropValue::Bool(value)),
            OpenvrProperty::SecondsFromVsyncToPhotons(value) => (2001, OpenvrPropValue::Float(value)),
            OpenvrProperty::DisplayFrequency(value) => (2002, OpenvrPropValue::Float(value)),
            OpenvrProperty::UserIpdMeters(value) => (2003, OpenvrPropValue::Float(value)),
            OpenvrProperty::CurrentUniverseId(value) => (2004, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::PreviousUniverseId(value) => (2005, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::DisplayFirmwareVersion(value) => (2006, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::IsOnDesktop(value) => (2007, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplayMCType(value) => (2008, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DisplayMCOffset(value) => (2009, OpenvrPropValue::Float(value)),
            OpenvrProperty::DisplayMCScale(value) => (2010, OpenvrPropValue::Float(value)),
            OpenvrProperty::EdidVendorID(value) => (2011, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DisplayMCImageLeft(value) => (2012, OpenvrPropValue::String(value)),
            OpenvrProperty::DisplayMCImageRight(value) => (2013, OpenvrPropValue::String(value)),
            OpenvrProperty::DisplayGCBlackClamp(value) => (2014, OpenvrPropValue::Float(value)),
            OpenvrProperty::EdidProductID(value) => (2015, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DisplayGCType(value) => (2017, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DisplayGCOffset(value) => (2018, OpenvrPropValue::Float(value)),
            OpenvrProperty::DisplayGCScale(value) => (2019, OpenvrPropValue::Float(value)),
            OpenvrProperty::DisplayGCPrescale(value) => (2020, OpenvrPropValue::Float(value)),
            OpenvrProperty::DisplayGCImage(value) => (2021, OpenvrPropValue::String(value)),
            OpenvrProperty::LensCenterLeftU(value) => (2022, OpenvrPropValue::Float(value)),
            OpenvrProperty::LensCenterLeftV(value) => (2023, OpenvrPropValue::Float(value)),
            OpenvrProperty::LensCenterRightU(value) => (2024, OpenvrPropValue::Float(value)),
            OpenvrProperty::LensCenterRightV(value) => (2025, OpenvrPropValue::Float(value)),
            OpenvrProperty::UserHeadToEyeDepthMeters(value) => (2026, OpenvrPropValue::Float(value)),
            OpenvrProperty::CameraFirmwareVersion(value) => (2027, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::CameraFirmwareDescription(value) => (2028, OpenvrPropValue::String(value)),
            OpenvrProperty::DisplayFPGAVersion(value) => (2029, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::DisplayBootloaderVersion(value) => (2030, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::DisplayHardwareVersion(value) => (2031, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::AudioFirmwareVersion(value) => (2032, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::CameraCompatibilityMode(value) => (2033, OpenvrPropValue::Int32(value)),
            OpenvrProperty::ScreenshotHorizontalFieldOfViewDegrees(value) => (2034, OpenvrPropValue::Float(value)),
            OpenvrProperty::ScreenshotVerticalFieldOfViewDegrees(value) => (2035, OpenvrPropValue::Float(value)),
            OpenvrProperty::DisplaySuppressed(value) => (2036, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplayAllowNightMode(value) => (2037, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplayMCImageWidth(value) => (2038, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DisplayMCImageHeight(value) => (2039, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DisplayMCImageNumChannels(value) => (2040, OpenvrPropValue::Int32(value)),
            OpenvrProperty::SecondsFromPhotonsToVblank(value) => (2042, OpenvrPropValue::Float(value)),
            OpenvrProperty::DriverDirectModeSendsVsyncEvents(value) => (2043, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplayDebugMode(value) => (2044, OpenvrPropValue::Bool(value)),
            OpenvrProperty::GraphicsAdapterLuid(value) => (2045, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::DriverProvidedChaperonePath(value) => (2048, OpenvrPropValue::String(value)),
            OpenvrProperty::ExpectedTrackingReferenceCount(value) => (2049, OpenvrPropValue::Int32(value)),
            OpenvrProperty::ExpectedControllerCount(value) => (2050, OpenvrPropValue::Int32(value)),
            OpenvrProperty::NamedIconPathControllerLeftDeviceOff(value) => (2051, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathControllerRightDeviceOff(value) => (2052, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathTrackingReferenceDeviceOff(value) => (2053, OpenvrPropValue::String(value)),
            OpenvrProperty::DoNotApplyPrediction(value) => (2054, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DistortionMeshResolution(value) => (2056, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverIsDrawingControllers(value) => (2057, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DriverRequestsApplicationPause(value) => (2058, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DriverRequestsReducedRendering(value) => (2059, OpenvrPropValue::Bool(value)),
            OpenvrProperty::MinimumIpdStepMeters(value) => (2060, OpenvrPropValue::Float(value)),
            OpenvrProperty::AudioBridgeFirmwareVersion(value) => (2061, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::ImageBridgeFirmwareVersion(value) => (2062, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::ImuFactoryGyroBias(value) => (2064, OpenvrPropValue::Vector3(value)),
            OpenvrProperty::ImuFactoryGyroScale(value) => (2065, OpenvrPropValue::Vector3(value)),
            OpenvrProperty::ImuFactoryAccelerometerBias(value) => (2066, OpenvrPropValue::Vector3(value)),
            OpenvrProperty::ImuFactoryAccelerometerScale(value) => (2067, OpenvrPropValue::Vector3(value)),
            OpenvrProperty::ConfigurationIncludesLighthouse20Features(value) => (2069, OpenvrPropValue::Bool(value)),
            OpenvrProperty::AdditionalRadioFeatures(value) => (2070, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::ExpectedControllerType(value) => (2074, OpenvrPropValue::String(value)),
            OpenvrProperty::HmdTrackingStyle(value) => (2075, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverProvidedChaperoneVisibility(value) => (2076, OpenvrPropValue::Bool(value)),
            OpenvrProperty::HmdColumnCorrectionSettingPrefix(value) => (2077, OpenvrPropValue::String(value)),
            OpenvrProperty::CameraSupportsCompatibilityModes(value) => (2078, OpenvrPropValue::Bool(value)),
            OpenvrProperty::SupportsRoomViewDepthProjection(value) => (2079, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplaySupportsMultipleFramerates(value) => (2081, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplayColorMultLeft(value) => (2082, OpenvrPropValue::Vector3(value)),
            OpenvrProperty::DisplayColorMultRight(value) => (2083, OpenvrPropValue::Vector3(value)),
            OpenvrProperty::DisplaySupportsRuntimeFramerateChange(value) => (2084, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplaySupportsAnalogGain(value) => (2085, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DisplayMinAnalogGain(value) => (2086, OpenvrPropValue::Float(value)),
            OpenvrProperty::DisplayMaxAnalogGain(value) => (2087, OpenvrPropValue::Float(value)),
            OpenvrProperty::DashboardScale(value) => (2091, OpenvrPropValue::Float(value)),
            OpenvrProperty::IpdUIRangeMinMeters(value) => (2100, OpenvrPropValue::Float(value)),
            OpenvrProperty::IpdUIRangeMaxMeters(value) => (2101, OpenvrPropValue::Float(value)),
            OpenvrProperty::HmdSupportsHDCP14LegacyCompat(value) => (2102, OpenvrPropValue::Bool(value)),
            OpenvrProperty::HmdSupportsMicMonitoring(value) => (2103, OpenvrPropValue::Bool(value)),
            OpenvrProperty::DriverRequestedMuraCorrectionMode(value) => (2200, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherInnerLeft(value) => (2201, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherInnerRight(value) => (2202, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherInnerTop(value) => (2203, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherInnerBottom(value) => (2204, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherOuterLeft(value) => (2205, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherOuterRight(value) => (2206, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherOuterTop(value) => (2207, OpenvrPropValue::Int32(value)),
            OpenvrProperty::DriverRequestedMuraFeatherOuterBottom(value) => (2208, OpenvrPropValue::Int32(value)),
            OpenvrProperty::AudioDefaultPlaybackDeviceId(value) => (2300, OpenvrPropValue::String(value)),
            OpenvrProperty::AudioDefaultRecordingDeviceId(value) => (2301, OpenvrPropValue::String(value)),
            OpenvrProperty::AudioDefaultPlaybackDeviceVolume(value) => (2302, OpenvrPropValue::Float(value)),
            OpenvrProperty::AudioSupportsDualSpeakerAndJackOutput(value) => (2303, OpenvrPropValue::Bool(value)),
            OpenvrProperty::AttachedDeviceId(value) => (3000, OpenvrPropValue::String(value)),
            OpenvrProperty::SupportedButtons(value) => (3001, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::Axis0Type(value) => (3002, OpenvrPropValue::Int32(value)),
            OpenvrProperty::Axis1Type(value) => (3003, OpenvrPropValue::Int32(value)),
            OpenvrProperty::Axis2Type(value) => (3004, OpenvrPropValue::Int32(value)),
            OpenvrProperty::Axis3Type(value) => (3005, OpenvrPropValue::Int32(value)),
            OpenvrProperty::Axis4Type(value) => (3006, OpenvrPropValue::Int32(value)),
            OpenvrProperty::ControllerRoleHint(value) => (3007, OpenvrPropValue::Int32(value)),
            OpenvrProperty::FieldOfViewLeftDegrees(value) => (4000, OpenvrPropValue::Float(value)),
            OpenvrProperty::FieldOfViewRightDegrees(value) => (4001, OpenvrPropValue::Float(value)),
            OpenvrProperty::FieldOfViewTopDegrees(value) => (4002, OpenvrPropValue::Float(value)),
            OpenvrProperty::FieldOfViewBottomDegrees(value) => (4003, OpenvrPropValue::Float(value)),
            OpenvrProperty::TrackingRangeMinimumMeters(value) => (4004, OpenvrPropValue::Float(value)),
            OpenvrProperty::TrackingRangeMaximumMeters(value) => (4005, OpenvrPropValue::Float(value)),
            OpenvrProperty::ModeLabel(value) => (4006, OpenvrPropValue::String(value)),
            OpenvrProperty::CanWirelessIdentify(value) => (4007, OpenvrPropValue::Bool(value)),
            OpenvrProperty::Nonce(value) => (4008, OpenvrPropValue::Int32(value)),
            OpenvrProperty::IconPathName(value) => (5000, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceOff(value) => (5001, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceSearching(value) => (5002, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceSearchingAlert(value) => (5003, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceReady(value) => (5004, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceReadyAlert(value) => (5005, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceNotReady(value) => (5006, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceStandby(value) => (5007, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceAlertLow(value) => (5008, OpenvrPropValue::String(value)),
            OpenvrProperty::NamedIconPathDeviceStandbyAlert(value) => (5009, OpenvrPropValue::String(value)),
            OpenvrProperty::OverrideContainer(value) => (5152, OpenvrPropValue::Uint64(value)),
            OpenvrProperty::UserConfigPath(value) => (6000, OpenvrPropValue::String(value)),
            OpenvrProperty::InstallPath(value) => (6001, OpenvrPropValue::String(value)),
            OpenvrProperty::HasDisplayComponent(value) => (6002, OpenvrPropValue::Bool(value)),
            OpenvrProperty::HasControllerComponent(value) => (6003, OpenvrPropValue::Bool(value)),
            OpenvrProperty::HasCameraComponent(value) => (6004, OpenvrPropValue::Bool(value)),
            OpenvrProperty::HasDriverDirectModeComponent(value) => (6005, OpenvrPropValue::Bool(value)),
            OpenvrProperty::HasVirtualDisplayComponent(value) => (6006, OpenvrPropValue::Bool(value)),
            OpenvrProperty::HasSpatialAnchorsSupport(value) => (6007, OpenvrPropValue::Bool(value)),
            OpenvrProperty::ControllerType(value) => (7000, OpenvrPropValue::String(value)),
            OpenvrProperty::ControllerHandSelectionPriority(value) => (7002, OpenvrPropValue::Int32(value)),
        }
    }
}

static OPENVR_PROPS_DEFAULT: alvr_common::once_cell::sync::Lazy<OpenvrPropertyDefault> = 
    alvr_common::once_cell::sync::Lazy::new(|| OpenvrPropertyDefault {
        TrackingSystemName: String::new(),
        ModelNumber: String::new(),
        SerialNumber: String::new(),
        RenderModelName: String::new(),
        WillDriftInYaw: false,
        ManufacturerName: String::new(),
        TrackingFirmwareVersion: String::new(),
        HardwareRevisionString: String::new(),
        AllWirelessDongleDescriptions: String::new(),
        ConnectedWirelessDongle: String::new(),
        DeviceIsWireless: false,
        DeviceIsCharging: false,
        DeviceBatteryPercentage: 0.0,
        FirmwareUpdateAvailable: false,
        FirmwareManualUpdate: false,
        FirmwareManualUpdateURL: String::new(),
        HardwareRevisionUint64: 0,
        FirmwareVersion: 0,
        FPGAVersion: 0,
        VRCVersion: 0,
        RadioVersion: 0,
        DongleVersion: 0,
        BlockServerShutdown: false,
        CanUnifyCoordinateSystemWithHmd: false,
        ContainsProximitySensor: false,
        DeviceProvidesBatteryStatus: false,
        DeviceCanPowerOff: false,
        FirmwareProgrammingTarget: String::new(),
        DeviceClass: 0,
        HasCamera: false,
        DriverVersion: String::new(),
        FirmwareForceUpdateRequired: false,
        ViveSystemButtonFixRequired: false,
        ParentDriver: 0,
        ResourceRoot: String::new(),
        RegisteredDeviceType: String::new(),
        InputProfilePath: String::new(),
        NeverTracked: false,
        NumCameras: 0,
        CameraFrameLayout: 0,
        CameraStreamFormat: 0,
        AdditionalDeviceSettingsPath: String::new(),
        Identifiable: false,
        BootloaderVersion: 0,
        AdditionalSystemReportData: String::new(),
        CompositeFirmwareVersion: String::new(),
        FirmwareRemindUpdate: false,
        PeripheralApplicationVersion: 0,
        ManufacturerSerialNumber: String::new(),
        ComputedSerialNumber: String::new(),
        EstimatedDeviceFirstUseTime: 0,
        ReportsTimeSinceVSync: false,
        SecondsFromVsyncToPhotons: 0.0,
        DisplayFrequency: 0.0,
        UserIpdMeters: 0.0,
        CurrentUniverseId: 0,
        PreviousUniverseId: 0,
        DisplayFirmwareVersion: 0,
        IsOnDesktop: false,
        DisplayMCType: 0,
        DisplayMCOffset: 0.0,
        DisplayMCScale: 0.0,
        EdidVendorID: 0,
        DisplayMCImageLeft: String::new(),
        DisplayMCImageRight: String::new(),
        DisplayGCBlackClamp: 0.0,
        EdidProductID: 0,
        DisplayGCType: 0,
        DisplayGCOffset: 0.0,
        DisplayGCScale: 0.0,
        DisplayGCPrescale: 0.0,
        DisplayGCImage: String::new(),
        LensCenterLeftU: 0.0,
        LensCenterLeftV: 0.0,
        LensCenterRightU: 0.0,
        LensCenterRightV: 0.0,
        UserHeadToEyeDepthMeters: 0.0,
        CameraFirmwareVersion: 0,
        CameraFirmwareDescription: String::new(),
        DisplayFPGAVersion: 0,
        DisplayBootloaderVersion: 0,
        DisplayHardwareVersion: 0,
        AudioFirmwareVersion: 0,
        CameraCompatibilityMode: 0,
        ScreenshotHorizontalFieldOfViewDegrees: 0.0,
        ScreenshotVerticalFieldOfViewDegrees: 0.0,
        DisplaySuppressed: false,
        DisplayAllowNightMode: false,
        DisplayMCImageWidth: 0,
        DisplayMCImageHeight: 0,
        DisplayMCImageNumChannels: 0,
        SecondsFromPhotonsToVblank: 0.0,
        DriverDirectModeSendsVsyncEvents: false,
        DisplayDebugMode: false,
        GraphicsAdapterLuid: 0,
        DriverProvidedChaperonePath: String::new(),
        ExpectedTrackingReferenceCount: 0,
        ExpectedControllerCount: 0,
        NamedIconPathControllerLeftDeviceOff: String::new(),
        NamedIconPathControllerRightDeviceOff: String::new(),
        NamedIconPathTrackingReferenceDeviceOff: String::new(),
        DoNotApplyPrediction: false,
        DistortionMeshResolution: 0,
        DriverIsDrawingControllers: false,
        DriverRequestsApplicationPause: false,
        DriverRequestsReducedRendering: false,
        MinimumIpdStepMeters: 0.0,
        AudioBridgeFirmwareVersion: 0,
        ImageBridgeFirmwareVersion: 0,
        ImuFactoryGyroBias: ArrayDefault {
            gui_collapsed: false,
            content: [0.0, 0.0, 0.0],
        },
        ImuFactoryGyroScale: ArrayDefault {
            gui_collapsed: false,
            content: [0.0, 0.0, 0.0],
        },
        ImuFactoryAccelerometerBias: ArrayDefault {
            gui_collapsed: false,
            content: [0.0, 0.0, 0.0],
        },
        ImuFactoryAccelerometerScale: ArrayDefault {
            gui_collapsed: false,
            content: [0.0, 0.0, 0.0],
        },
        ConfigurationIncludesLighthouse20Features: false,
        AdditionalRadioFeatures: 0,
        ExpectedControllerType: String::new(),
        HmdTrackingStyle: 0,
        DriverProvidedChaperoneVisibility: false,
        HmdColumnCorrectionSettingPrefix: String::new(),
        CameraSupportsCompatibilityModes: false,
        SupportsRoomViewDepthProjection: false,
        DisplaySupportsMultipleFramerates: false,
        DisplayColorMultLeft: ArrayDefault {
            gui_collapsed: false,
            content: [0.0, 0.0, 0.0],
        },
        DisplayColorMultRight: ArrayDefault {
            gui_collapsed: false,
            content: [0.0, 0.0, 0.0],
        },
        DisplaySupportsRuntimeFramerateChange: false,
        DisplaySupportsAnalogGain: false,
        DisplayMinAnalogGain: 0.0,
        DisplayMaxAnalogGain: 0.0,
        DashboardScale: 0.0,
        IpdUIRangeMinMeters: 0.0,
        IpdUIRangeMaxMeters: 0.0,
        HmdSupportsHDCP14LegacyCompat: false,
        HmdSupportsMicMonitoring: false,
        DriverRequestedMuraCorrectionMode: 0,
        DriverRequestedMuraFeatherInnerLeft: 0,
        DriverRequestedMuraFeatherInnerRight: 0,
        DriverRequestedMuraFeatherInnerTop: 0,
        DriverRequestedMuraFeatherInnerBottom: 0,
        DriverRequestedMuraFeatherOuterLeft: 0,
        DriverRequestedMuraFeatherOuterRight: 0,
        DriverRequestedMuraFeatherOuterTop: 0,
        DriverRequestedMuraFeatherOuterBottom: 0,
        AudioDefaultPlaybackDeviceId: String::new(),
        AudioDefaultRecordingDeviceId: String::new(),
        AudioDefaultPlaybackDeviceVolume: 0.0,
        AudioSupportsDualSpeakerAndJackOutput: false,
        AttachedDeviceId: String::new(),
        SupportedButtons: 0,
        Axis0Type: 0,
        Axis1Type: 0,
        Axis2Type: 0,
        Axis3Type: 0,
        Axis4Type: 0,
        ControllerRoleHint: 0,
        FieldOfViewLeftDegrees: 0.0,
        FieldOfViewRightDegrees: 0.0,
        FieldOfViewTopDegrees: 0.0,
        FieldOfViewBottomDegrees: 0.0,
        TrackingRangeMinimumMeters: 0.0,
        TrackingRangeMaximumMeters: 0.0,
        ModeLabel: String::new(),
        CanWirelessIdentify: false,
        Nonce: 0,
        IconPathName: String::new(),
        NamedIconPathDeviceOff: String::new(),
        NamedIconPathDeviceSearching: String::new(),
        NamedIconPathDeviceSearchingAlert: String::new(),
        NamedIconPathDeviceReady: String::new(),
        NamedIconPathDeviceReadyAlert: String::new(),
        NamedIconPathDeviceNotReady: String::new(),
        NamedIconPathDeviceStandby: String::new(),
        NamedIconPathDeviceAlertLow: String::new(),
        NamedIconPathDeviceStandbyAlert: String::new(),
        OverrideContainer: 0,
        UserConfigPath: String::new(),
        InstallPath: String::new(),
        HasDisplayComponent: false,
        HasControllerComponent: false,
        HasCameraComponent: false,
        HasDriverDirectModeComponent: false,
        HasVirtualDisplayComponent: false,
        HasSpatialAnchorsSupport: false,
        ControllerType: String::new(),
        ControllerHandSelectionPriority: 0,
        variant: OpenvrPropertyDefaultVariant::TrackingSystemName,
    });
